-- WARNING: Do NOT edit the input and output ports in this file in a text
-- editor if you plan to continue editing the block that represents it in
-- the Block Editor! File corruption is VERY likely to occur.

-- Copyright (C) 1991-2013 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions
-- and other software and tools, and its AMPP partner logic
-- functions, and any output files from any of the foregoing
-- (including device programming or simulation files), and any
-- associated documentation or information are expressly subject
-- to the terms and conditions of the Altera Program License
-- Subscription Agreement, Altera MegaCore Function License
-- Agreement, or other applicable license agreement, including,
-- without limitation, that your use is for the sole purpose of
-- programming logic devices manufactured by Altera and sold by
-- Altera or its authorized distributors.  Please refer to the
-- applicable agreement for further details.


-- Generated by Quartus II 32-bit Version 13.0 (Build Build 232 06/12/2013)
-- Created on Thu Jan 29 14:23:22 2015

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use IEEE.NUMERIC_STD.all;
use ieee.std_logic_misc.all;


--  Entity Declaration

ENTITY i2c_interface IS
-- {{ALTERA_IO_BEGIN}} DO NOT REMOVE THIS LINE!
  PORT
    (
      reset : in std_logic;
      clk     : in std_logic;
      SDA_in  : in std_logic;
      SDA_out : out std_logic;
      SDA_en  : out std_logic;
      SCL     : in std_logic;
      i2c_address : in std_logic_vector(6 downto 0);
      
      reg_out_0 : out std_logic_vector(15 downto 0);
      reg_out_1 : out std_logic_vector(15 downto 0);
      reg_out_2 : out std_logic_vector(15 downto 0);
      reg_out_3 : out std_logic_vector(15 downto 0);
      reg_out_4 : out std_logic_vector(15 downto 0);
      reg_out_5 : out std_logic_vector(15 downto 0);
      reg_out_6 : out std_logic_vector(15 downto 0);
      reg_out_7 : out std_logic_vector(15 downto 0);
      reg_out_8 : out std_logic_vector(15 downto 0);
      reg_out_9 : out std_logic_vector(15 downto 0);
      reg_out_10 : out std_logic_vector(15 downto 0);
      reg_out_11 : out std_logic_vector(15 downto 0);
      reg_out_12 : out std_logic_vector(15 downto 0);
      reg_out_13 : out std_logic_vector(15 downto 0);
      reg_out_14 : out std_logic_vector(15 downto 0);
      reg_out_15 : out std_logic_vector(15 downto 0);
      
      reg_in_0 : in std_logic_vector(15 downto 0);
      reg_in_1 : in std_logic_vector(15 downto 0);
      reg_in_2 : in std_logic_vector(15 downto 0);
      reg_in_3 : in std_logic_vector(15 downto 0);
      reg_in_4 : in std_logic_vector(15 downto 0);
      reg_in_5 : in std_logic_vector(15 downto 0);
      reg_in_6 : in std_logic_vector(15 downto 0);
      reg_in_7 : in std_logic_vector(15 downto 0);
      reg_in_8 : in std_logic_vector(15 downto 0);
      reg_in_9 : in std_logic_vector(15 downto 0);
      reg_in_10 : in std_logic_vector(15 downto 0);
      reg_in_11 : in std_logic_vector(15 downto 0);
      reg_in_12 : in std_logic_vector(15 downto 0);
      reg_in_13 : in std_logic_vector(15 downto 0);
      reg_in_14 : in std_logic_vector(15 downto 0);
      reg_in_15 : in std_logic_vector(15 downto 0)
      
      );
-- {{ALTERA_IO_END}} DO NOT REMOVE THIS LINE!

END i2c_interface;


--  Architecture Body

ARCHITECTURE i2c_interface_architecture OF i2c_interface IS

  -----------------------------------------------------------------------------
  -- i2c slave
  -----------------------------------------------------------------------------
  component i2c_slave
    generic (
      REGISTER_COUNT : integer);
    port (
      reset       : in    std_logic;
      clk     : in std_logic;

      SDA_in  : in std_logic;
      SDA_out : out std_logic;
      SDA_en  : out std_logic;
      SCL         : in    std_logic;
      address     : in    std_logic_vector(6 downto 0);
      data_out    : out   std_logic_vector(7 downto 0);
      data_out_dv : out   std_logic;
      data_in     : in    std_logic_vector(7 downto 0);
      register_address    : out   unsigned(7 downto 0);
      test : out std_logic_vector(7 downto 0));
  end component;

  -----------------------------------------------------------------------------
  -- signals
  -----------------------------------------------------------------------------
  type register_block is array (0 to 15) of std_logic_vector(15 downto 0);
  constant i2c_register_default : register_block := (x"0000",x"0000",x"FFFF",x"0000",x"FFFd",x"FFFe",x"FFFF",x"0000",x"0000",x"0000",x"0000",x"0000",x"0000",x"0000",x"0000",x"0000");
  signal i2c_register : register_block := i2c_register_default;
  signal i2c_register_in : register_block := i2c_register_default;
  signal data_out : std_logic_vector(7 downto 0) := x"00";
  signal data_in : std_logic_vector(7 downto 0);
  signal register_address : unsigned(7 downto 0);
  signal data_out_dv : std_logic := '0';
  
  
begin  -- Behavioral

  i2c_slave_1: i2c_slave
    generic map (
      REGISTER_COUNT => 16)
    port map (
      reset       => reset,
      clk => clk,

      SDA_in         => SDA_in,
      SDA_out         => SDA_out,
      SDA_en         => SDA_en,
      
      SCL         => SCL,
      address     => i2c_address,
      data_out    => data_out,
      data_out_dv => data_out_dv,
      data_in     => data_in,
      register_address    => register_address,
      test => open);


  -- Map I/O ports to arrays
  i2c_register_in(0) <= reg_in_0;
  i2c_register_in(1) <= reg_in_1;
  i2c_register_in(2) <= reg_in_2;
  i2c_register_in(3) <= reg_in_3;
  i2c_register_in(4) <= reg_in_4;
  i2c_register_in(5) <= reg_in_5;
  i2c_register_in(6) <= reg_in_6;
  i2c_register_in(7) <= reg_in_7;
  i2c_register_in(8) <= reg_in_8;
  i2c_register_in(9) <= reg_in_9;
  i2c_register_in(10) <= reg_in_10;
  i2c_register_in(11) <= reg_in_11;
  i2c_register_in(12) <= reg_in_12;
  i2c_register_in(13) <= reg_in_13;
  i2c_register_in(14) <= reg_in_14;
  i2c_register_in(15) <= reg_in_15;
  
  reg_out_0 <= i2c_register(0);
  reg_out_1 <= i2c_register(1);
  reg_out_2 <= i2c_register(2);
  reg_out_3 <= i2c_register(3);
  reg_out_4 <= i2c_register(4);
  reg_out_5 <= i2c_register(5);
  reg_out_6 <= i2c_register(6);
  reg_out_7 <= i2c_register(7);
  reg_out_8 <= i2c_register(8);
  reg_out_9 <= i2c_register(9);
  reg_out_10 <= i2c_register(10);
  reg_out_11 <= i2c_register(11);
  reg_out_12 <= i2c_register(12);
  reg_out_13 <= i2c_register(13);
  reg_out_14 <= i2c_register(14);
  reg_out_15 <= i2c_register(15);

  
  
  register_read: process (clk, reset)
  begin  -- process register_read
    if reset = '1' then                 -- asynchronous reset (active high)
      
    elsif clk'event and clk = '1' then  -- rising clock edge      
      if register_address(0) = '1' then      
        data_in <= i2c_register_in(to_integer(register_address(4 downto 1)))(7 downto 0);
      else
        data_in <= i2c_register_in(to_integer(register_address(4 downto 1)))(15 downto 8);
      end if;            
    end if;
  end process register_read;


  register_update_map: for iReg in 0 to 15 generate
    reg_write: process (clk, reset)
    begin  -- process reg_write
      if reset = '1' then               -- asynchronous reset (active high)
        i2c_register(iReg) <= i2c_register_default(iReg);
      elsif clk'event and clk = '1' then  -- rising clock edge
        -- update the output registers from the i2c bus
        if (to_integer(register_address(4 downto 1)) = iReg) and data_out_dv = '1' then
          if register_address(0) = '1' then
            i2c_register(iReg)(7 downto 0) <= data_out;
          else
            i2c_register(iReg)(15 downto 8) <= data_out;
          end if;
        end if;
      end if;
    end process reg_write;
  end generate register_update_map;
  


END i2c_interface_architecture;
